﻿package {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	//ドキュメントクラスに指定して使う
	public class PickAnime extends MovieClip {
		var stageRect:Rectangle;
		var center:Point;
		//コンストラクタ
		function PickAnime() {
			stageRect = new Rectangle(0, 0, stage.stageWidth, stage.stageHeight);
			center = new Point(stage.stageWidth/2, stage.stageHeight/2);
			make1stMC();
		}
		//最初の1個を作る
		function make1stMC() {
			//Pickリンケージシンボルからインスタンスを作る
			var pick_mc:Pick = new Pick();
			pick_mc.rotation = Math.random()*360;
			pick_mc.x = center.x;
			pick_mc.y = center.y;
			addChild(pick_mc);
			//mcに仕込んであるカスタムイベント
			pick_mc.addEventListener("animeDone",onAnimeDone);
		}
		//アニメーション終了
		function onAnimeDone(event:Event):void {
			var mc:MovieClip = event.target as MovieClip;
			mc.removeEventListener("animeDone",onAnimeDone);
			mc.addEventListener(Event.ENTER_FRAME, fadeOutStep);
			nextPick(mc);
		}
		//次のインスタンスを作る
		function nextPick(targetMC:MovieClip):void {
			var angle:int;
			var pt:Point= new Point(40, 0);
			//mcの尖った位置をグローバル座標に変換する
			var gPt:Point = targetMC.localToGlobal(pt);
			//尖った位置がステージ領域に入っているかどうか
			if (stageRect.containsPoint(gPt)) {
				angle = (Math.random()*180 - 90) + targetMC.rotation;
			} else {
				//ステージセンター方向の角度を調べる
				angle = Math.atan2(center.y-gPt.y, center.x-gPt.x)*180/Math.PI;
			}
			//Pickリンケージシンボルからインスタンスを作る
			var pick_mc:Pick=new Pick();
			pick_mc.rotation = angle;
			pick_mc.x=gPt.x;
			pick_mc.y=gPt.y;
			addChild(pick_mc);
			//mcに仕込んであるカスタムイベント
			pick_mc.addEventListener("animeDone",onAnimeDone);
		}
		//フェードアウトして消える
		function fadeOutStep(event:Event):void {
			var mc:MovieClip = event.target as MovieClip;
			if (mc.alpha == 0) {
				mc.removeEventListener(Event.ENTER_FRAME, fadeOutStep);
				removeChild(mc);
				//メモリから解放する
				mc = null;
			} else {
				mc.alpha -= 0.01;
			}
		}
	}
}